/*####################################################################
 FILE: TCN75A_example.ino
 VERSION: 1.0
 PURPOSE: Digital Temperature Sensor with TCN75A test sketch

 Description:
 * Communicates with the TCN75A sensor via the I2C bus.
 * Readings are converted to Celsius degrees and displayed on the Serial Monitor.

 Connections:
 * BOARD -> ARDUINO
 * Vcc   -> 5V
 * GND   -> GND
 * SDA   -> A4
 * SCL   -> A5

 HISTORY:
  Mirko Prosseda - Original version (20/11/2012)
#######################################################################*/


#include <Wire.h>   // library used with I2C protocol
#include <TCN75A.h>

TCN75A sensor;

void setup()
{
  int w_reg;
  Serial.begin(9600);
  sensor.begin();
  sensor.set_address(0);
  sensor.set_resolution(3);
  Serial.println("Microbot Digital Temperature Sensor with TCN75A Test Program");
  Serial.print("LIBRARY VERSION: ");
  Serial.println(TCN75ALIB_VERSION);
  delay(500);
}

void loop()
{
  float t = sensor.read();

  // displays temperature in the Serial Monitor
  Serial.print("Temperature: ");
  Serial.println(t,4);         // temperature is displayed with 4 decimal places
  delay(500);                  // wait 500ms before repeating the cycle
}
